CREATE TABLE REST_DATA_SET (
	REST_DATA_SET_ID NUMBER NOT NULL,
	RESOURCE_NAME VARCHAR2(100 CHAR) NOT NULL,
	DESCRIPTION VARCHAR2(1024 CHAR),
	VIEW_NAME VARCHAR2(100 CHAR),
    QUERY_TEXT CLOB,
    PARAMS VARCHAR2(2048 CHAR),
	CONSTRAINT REST_DATA_SET_PK PRIMARY KEY (REST_DATA_SET_ID),
	CONSTRAINT REST_DATA_SET_U01 UNIQUE(RESOURCE_NAME),
    CONSTRAINT REST_DATA_SET_CHK01 CHECK(VIEW_NAME IS NOT NULL OR QUERY_TEXT IS NOT NULL)
);

CREATE SEQUENCE REST_DATA_SET_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2190, SYSDATE, '5.5', 2110, 'getData REST')
;

