CREATE OR REPLACE FORCE VIEW V_NASLOVI (ID_KUPCA, COMPANY_NAME, NATURE_OF_BUSINESS, BUSINESS_ADDRESS, OVERSEAS_ADDRESS, HOME_TELEPHONE, COMPANY_TELEPHONE, PERSONAL_FAX, COMPANY_FAX, PERSONAL_EMAIL, COMPANY_EMAIL, MOBILE_PHONE, FACEBOOK, TWITTER, LINKEDIN, WHATSAPP, OVERSEAS_TELEPHONE, OVERSEAS_FAX, OVERSEAS_EMAIL, OVERSEAS_MOBILE, COMPANY_MOBILE, OTHER_EMAIL, BUSINESS_ADDRESS_PREF, OVERSEAS_ADDRESS_PREF, HOME_TELEPHONE_PREF, COMPANY_TELEPHONE_PREF, PERSONAL_FAX_PREF, COMPANY_FAX_PREF, PERSONAL_EMAIL_PREF, COMPANY_EMAIL_PREF, MOBILE_PHONE_PREF, OVERSEAS_TELEPHONE_PREF, OVERSEAS_FAX_PREF, OVERSEAS_EMAIL_PREF, OVERSEAS_MOBILE_PREF, COMPANY_MOBILE_PREF, OTHER_EMAIL_PREF) 
AS 
  SELECT ID_KUPCA, MAX(COMPANY_NAME) COMPANY_NAME, MAX(NATURE_OF_BUSINESS) NATURE_OF_BUSINESS, MAX(BUSINESS_ADDRESS) BUSINESS_ADDRESS, MAX(OVERSEAS_ADDRESS) OVERSEAS_ADDRESS, MAX(HOME_TELEPHONE) HOME_TELEPHONE, 
         MAX(COMPANY_TELEPHONE) COMPANY_TELEPHONE,  MAX(PERSONAL_FAX) PERSONAL_FAX, MAX(COMPANY_FAX) COMPANY_FAX, 
         MAX(PERSONAL_EMAIL) PERSONAL_EMAIL, MAX(COMPANY_EMAIL) COMPANY_EMAIL, MAX(MOBILE_PHONE) MOBILE_PHONE, MAX(FACEBOOK) FACEBOOK, MAX(TWITTER) TWITTER,
         MAX(LINKEDIN) LINKEDIN, MAX(WHATSAPP) WHATSAPP, MAX(OVERSEAS_TELEPHONE) OVERSEAS_TELEPHONE, MAX(OVERSEAS_FAX) OVERSEAS_FAX,
         MAX(OVERSEAS_EMAIL) OVERSEAS_EMAIL,  MAX(OVERSEAS_MOBILE) OVERSEAS_MOBILE,
         MAX(COMPANY_MOBILE) COMPANY_MOBILE, MAX(OTHER_EMAIL) OTHER_EMAIL,
         MAX(BUSINESS_ADDRESS_PREF) BUSINESS_ADDRESS_PREF, MAX(OVERSEAS_ADDRESS_PREF) OVERSEAS_ADDRESS_PREF, MAX(HOME_TELEPHONE_PREF) HOME_TELEPHONE_PREF, 
         MAX(COMPANY_TELEPHONE_PREF) COMPANY_TELEPHONE_PREF,  MAX(PERSONAL_FAX_PREF) PERSONAL_FAX_PREF, MAX(COMPANY_FAX_PREF) COMPANY_FAX_PREF, 
         MAX(PERSONAL_EMAIL_PREF) PERSONAL_EMAIL_PREF, MAX(COMPANY_EMAIL_PREF) COMPANY_EMAIL_PREF, MAX(MOBILE_PHONE_PREF) MOBILE_PHONE_PREF,
         MAX(OVERSEAS_TELEPHONE_PREF) OVERSEAS_TELEPHONE_PREF, MAX(OVERSEAS_FAX_PREF) OVERSEAS_FAX_PREF,
         MAX(OVERSEAS_EMAIL_PREF) OVERSEAS_EMAIL_PREF,  MAX(OVERSEAS_MOBILE_PREF) OVERSEAS_MOBILE_PREF, 
         MAX(COMPANY_MOBILE_PREF) COMPANY_MOBILE_PREF, MAX(OTHER_EMAIL_PREF) OTHER_EMAIL_PREF  FROM (
  (SELECT C.ID, C.ID_KUPCA, C.COMPANY_NAME, C.NATURE_OF_BUSINESS,
       CASE WHEN C.VRSTA_CORR='002' THEN LISTAGG(C.NASLOV||CHR(10)||C.POSTA||CHR(10)||C.KRAJ||CHR(10)||D_BUSINESS.OPIS,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS BUSINESS_ADDRESS,
       CASE WHEN C.VRSTA_CORR='003' THEN LISTAGG(C.NASLOV||CHR(10)||C.POSTA||CHR(10)||C.KRAJ||CHR(10)||D_OVERSEAS.OPIS,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS OVERSEAS_ADDRESS,
       CASE WHEN C.VRSTA_CORR='004' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS HOME_TELEPHONE,
       CASE WHEN C.VRSTA_CORR='005' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS COMPANY_TELEPHONE,
       CASE WHEN C.VRSTA_CORR='006' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS PERSONAL_FAX,
       CASE WHEN C.VRSTA_CORR='007' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS COMPANY_FAX,
       CASE WHEN C.VRSTA_CORR='008' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS PERSONAL_EMAIL,
       CASE WHEN C.VRSTA_CORR='009' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS COMPANY_EMAIL,
       CASE WHEN C.VRSTA_CORR='010' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS MOBILE_PHONE,
       CASE WHEN C.VRSTA_CORR='011' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS FACEBOOK,
       CASE WHEN C.VRSTA_CORR='012' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS TWITTER,
       CASE WHEN C.VRSTA_CORR='013' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS LINKEDIN,
       CASE WHEN C.VRSTA_CORR='014' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS WHATSAPP,
       CASE WHEN C.VRSTA_CORR='015' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS OVERSEAS_TELEPHONE,
       CASE WHEN C.VRSTA_CORR='016' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS OVERSEAS_FAX,
       CASE WHEN C.VRSTA_CORR='017' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS OVERSEAS_EMAIL,
       CASE WHEN C.VRSTA_CORR='018' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS OVERSEAS_MOBILE,
       CASE WHEN C.VRSTA_CORR='019' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS COMPANY_MOBILE,
       CASE WHEN C.VRSTA_CORR='020' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS OTHER_EMAIL,
       NULL AS BUSINESS_ADDRESS_PREF, NULL AS OVERSEAS_ADDRESS_PREF, NULL AS HOME_TELEPHONE_PREF, 
       NULL AS COMPANY_TELEPHONE_PREF, NULL AS PERSONAL_FAX_PREF, NULL AS COMPANY_FAX_PREF, 
       NULL AS PERSONAL_EMAIL_PREF, NULL AS COMPANY_EMAIL_PREF, NULL AS MOBILE_PHONE_PREF,
       NULL AS OVERSEAS_TELEPHONE_PREF, NULL AS OVERSEAS_FAX_PREF,
       NULL AS OVERSEAS_EMAIL_PREF, NULL AS OVERSEAS_MOBILE_PREF, 
       NULL AS COMPANY_MOBILE_PREF, NULL AS OTHER_EMAIL_PREF
FROM KUPCI_CORRESPONDENCE C
LEFT OUTER JOIN NNVRSCORR N ON N.SIFRA=C.VRSTA_CORR
LEFT OUTER JOIN NNDRZAVE D_BUSINESS ON D_BUSINESS.SIFRA=C.NDRZAVA AND C.VRSTA_CORR='002'
LEFT OUTER JOIN NNDRZAVE D_OVERSEAS ON D_OVERSEAS.SIFRA=C.NDRZAVA AND C.VRSTA_CORR='003'
WHERE C.AKT='Y'
GROUP BY C.ID, C.ID_KUPCA, C.VRSTA_CORR, C.COMPANY_NAME, C.NATURE_OF_BUSINESS)
UNION ALL
  (SELECT C.ID, C.ID_KUPCA, C.COMPANY_NAME, C.NATURE_OF_BUSINESS,
       NULL AS BUSINESS_ADDRESS, NULL AS OVERSEAS_ADDRESS, NULL AS  HOME_TELEPHONE, 
       NULL AS COMPANY_TELEPHONE, NULL AS PERSONAL_FAX, NULL AS  COMPANY_FAX, 
       NULL AS  PERSONAL_EMAIL, NULL AS  COMPANY_EMAIL, NULL AS MOBILE_PHONE, NULL AS FACEBOOK, NULL AS TWITTER,
       NULL AS LINKEDIN, NULL AS WHATSAPP, NULL AS OVERSEAS_TELEPHONE, NULL AS OVERSEAS_FAX,
       NULL AS OVERSEAS_EMAIL, NULL AS OVERSEAS_MOBILE,
       NULL AS COMPANY_MOBILE, NULL AS OTHER_EMAIL,
       CASE WHEN C.VRSTA_CORR='002' THEN LISTAGG(C.NASLOV||CHR(10)||C.POSTA||CHR(10)||C.KRAJ||CHR(10)||D_BUSINESS.OPIS,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS BUSINESS_ADDRESS_PREF,
       CASE WHEN C.VRSTA_CORR='003' THEN LISTAGG(C.NASLOV||CHR(10)||C.POSTA||CHR(10)||C.KRAJ||CHR(10)||D_OVERSEAS.OPIS,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS OVERSEAS_ADDRESS_PREF,
       CASE WHEN C.VRSTA_CORR='004' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS HOME_TELEPHONE_PREF,
       CASE WHEN C.VRSTA_CORR='005' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS COMPANY_TELEPHONE_PREF,
       CASE WHEN C.VRSTA_CORR='006' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS PERSONAL_FAX_PREF,
       CASE WHEN C.VRSTA_CORR='007' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS COMPANY_FAX_PREF,
       CASE WHEN C.VRSTA_CORR='008' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS PERSONAL_EMAIL_PREF,
       CASE WHEN C.VRSTA_CORR='009' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS COMPANY_EMAIL_PREF,
       CASE WHEN C.VRSTA_CORR='010' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS MOBILE_PHONE_PREF,
       CASE WHEN C.VRSTA_CORR='015' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS OVERSEAS_TELEPHONE_PREF,
       CASE WHEN C.VRSTA_CORR='016' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS OVERSEAS_FAX_PREF,
       CASE WHEN C.VRSTA_CORR='017' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS OVERSEAS_EMAIL_PREF,
       CASE WHEN C.VRSTA_CORR='018' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS OVERSEAS_MOBILE_PREF,
       CASE WHEN C.VRSTA_CORR='019' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS COMPANY_MOBILE_PREF,
       CASE WHEN C.VRSTA_CORR='020' THEN LISTAGG(C.NASLOV,'; ') WITHIN GROUP (ORDER BY C.ID) ELSE '' END AS OTHER_EMAIL_PREF
FROM KUPCI_CORRESPONDENCE C
LEFT OUTER JOIN NNVRSCORR N ON N.SIFRA=C.VRSTA_CORR
LEFT OUTER JOIN NNDRZAVE D_BUSINESS ON D_BUSINESS.SIFRA=C.NDRZAVA AND C.VRSTA_CORR='002'
LEFT OUTER JOIN NNDRZAVE D_OVERSEAS ON D_OVERSEAS.SIFRA=C.NDRZAVA AND C.VRSTA_CORR='003'
WHERE C.AKT='Y'
AND C.PREFERRED='Y'
GROUP BY C.ID, C.ID_KUPCA, C.VRSTA_CORR, C.COMPANY_NAME, C.NATURE_OF_BUSINESS))
GROUP BY ID_KUPCA
;

ALTER TABLE NRIGHTS
  ADD RIGHT_NR NUMBER;

UPDATE NRIGHTS
SET RIGHT_NR=100
WHERE PRAVICA='AFSTATUS';

insert into verzije_baza (id, dt_vpis, verzija, ver_nr, opis) 
values 
(489, SYSDATE, '5.5', 409, 'view korespondence and rights');
