DELETE FROM SIFRANT WHERE STRINGTABLE='NNVRSKUP_ATRIBUTI' AND ID_STRING='TYPE_COMPARE' 
AND KODA_SIFRANT IN ('SERVICE_Q', 'SERVICE_V', 'PRODUCT_Q', 'PRODUCT_V', 'GROUP_V', 'RESERVATION_Q')
;

INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'INC', 'Compare type', 'Income', 'INC', 'Income')
;
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'SRQ', 'Compare type', 'Service quantity', 'INC', 'Service quantity')
;
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'SRV', 'Compare type', 'Service value', 'INC', 'Service value')
;
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'PQ', 'Compare type', 'Product quantity', 'INC', 'Product quantity')
;
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'PRV', 'Compare type', 'Product value', 'INC', 'Product value')
;
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'GV', 'Compare type', 'Product group value', 'INC', 'Product group value')
;
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'REZ', 'Compare type', 'Reservation quantity', 'INC', 'Reservation quantity')
;
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'CON', 'Compare type', 'Contract days', 'INC', 'Contract days')
;
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'LOY', 'Compare type', 'Loyalty member', 'INC', 'Loyalty member')
;

UPDATE S_OBRACUN
SET DATE_CREATE = (SELECT D.DATUM FROM S_DOKUMENT D JOIN S_PROMET P ON D.ID_DOKUMENT=P.ID_DOKUMENT WHERE P.ID_PROMET=S_OBRACUN.ID_PROMET)
WHERE DATE_CREATE IS NULL
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1412, SYSDATE, '5.5', 1332, 'Loyalty')
;