DROP VIEW V_M_NNSTOMAR
;

CREATE OR REPLACE VIEW V_M_NNSTOMAR AS (
SELECT S.SIFRA, S.OPIS, S.INTERNI_OPIS, S.KAT, S.TIMEKAT, S.NNLOCATION_ID, S.FILTER, S.DAVEK, S.QUANTITY_INSTR, 
S.ENOTA, S.INSTR_PRICE, S.AUTO_CREATE_METHOD, S.ACC_CODE, S.NIGHTS_PRICE, S.TRIGGER_DEPOSIT, S.ROUNDING, S.AKT, 
S.PRIVEZ, S.SUBLEASE, S.BERTH_YIELD, S.MIN_PRICE, S.MAX_DISCOUNT, S.ID_VOUCHER_TYPE, S.VOUCHER_AMOUNT,
SF.OPIS AS FILTER_OPIS, SK.OPIS AS KAT_OPIS, ST.OPIS AS TIMEKAT_OPIS, S.NGRUPA, BR.ACCOUNT
FROM M_NNSTOMAR S
LEFT OUTER JOIN M_NNSKLOPI SK ON SK.KATEGORIJA=1 AND SK.SIFRA_SKLOPA=S.KAT
LEFT OUTER JOIN M_NNSKLOPI ST ON ST.KATEGORIJA=2 AND ST.SIFRA_SKLOPA=S.TIMEKAT
LEFT OUTER JOIN NNSTOFILTER SF ON SF.ID = S.FILTER
LEFT OUTER JOIN (SELECT DATA_CODE AS SERVICE, MIN(ACCOUNT) AS ACCOUNT FROM BOOKKEEPING_RULES WHERE TYPE='SERVICE_INCOME' AND ACCOUNT IS NOT NULL GROUP BY DATA_CODE) BR ON S.SIFRA=BR.SERVICE
)
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2177, SYSDATE, '5.5', 2097, 'V_M_NNSTOMAR')
;